<?php
load_theme_textdomain ('giraffe');

class G2_Skin
{
	var $name;
	var $base;
}

class G2_Admin
{
	function admin_link ()
	{
		echo get_bloginfo ('wpurl')."/wp-content/themes/giraffe2/admin/";
	}

	function get_width ()
	{
		if (G2C::get ('width') > 100)
			return G2C::get ('width')."px";
		return G2C::get ('width')."%";
	}

	function get_width_percent ()
	{
		$width = G2C::get ('width');
		if ($width > 100)
			$width = ($width / 1400) * 100;
		return $width."%";
	}

	function has_a_bar ()
	{
		if (G2C::get ('bar') == 'true')
			return true;
		return false;
	}

	function has_corners ()
	{
		if (G2C::get ('corners') == 'true')
			return true;
		return false;
	}

	function set_layout_from_post ()
	{
		G2C::set ('width', $_POST['width']);
		G2C::set ('colour', $_POST['colour']);
	  G2C::set ("width_left", $_POST['width_left']);
	  G2C::set ("width_right", $_POST['width_right']);

	  G2C::set ('logo_gradient', 'gradient/'.$_POST['colour'].".png");
	}

	function set_logo_from_post ()
	{
		file_uploads ($_FILES);

		G2C::set ('logo_height_units', $_POST['logo_height_units']);
		G2C::set ('logo_height', $_POST['logo_height']);
	  G2C::set ("logo_font", stripslashes ($_POST['logo_font']));
	  G2C::set ("logo_fontsize", $_POST['logo_fontsize']);
	  G2C::set ("logo_textalign", $_POST['logo_textalign']);
	  G2C::set ("logo_align", $_POST['logo_align']);
	  G2C::set ("logo_image", $_POST['logo_image']);
	  G2C::set ("logo_gradient", $_POST['logo_gradient']);
	  G2C::set ("logo_repeat", $_POST['logo_repeat']);
	  G2C::set ("logo_background", $_POST['logo_background']);
	  G2C::set ("logo_background_repeat", $_POST['logo_background_repeat']);

	  G2C::set_check ("logo_tagline");
	  G2C::set_check ("logo_title");
	}

	function set_options_from_post ()
	{
		G2C::set ('font', $_POST['font']);
	  G2C::set ("posts_lead", $_POST['posts_lead']);
	  G2C::set ("posts_other", $_POST['posts_other']);
	  G2C::set ("inset_count", $_POST['inset_count']);
	  G2C::set ("comments_recent", $_POST['comments_recent']);
	  G2C::set ("comments_order", $_POST['comments_order']);
	  G2C::set ("top_menu", $_POST['top_menu']);
	  G2C::set_footer (stripslashes ($_POST['footer']));
	  G2C::set_top_custom (stripslashes ($_POST['top_custom']));

		G2C::set_check ('corners');
		G2C::set_check ('bar');
		G2C::set_check ('comments_gravatar');
		G2C::set_check ('lead_full');
		G2C::set_check ('author');
		G2C::set_check ('ajax_comments');
	}

	function can_save ()
	{
		if (is_writable (ABSPATH.'wp-content/themes/giraffe2/admin/options.php'))
			return true;
		return false;
	}
	
	function save ()
	{
		G2C::save ();

		// And create the options.css file
    ob_start ();
		include (ABSPATH.'wp-content/themes/giraffe2/admin/options.php');
    $text = ob_get_contents ();
    ob_end_clean ();

		$options = ABSPATH.'wp-content/themes/giraffe2/options.css';
    if (($file = @fopen ($options, 'wb+')))
    {
    	fwrite ($file, $text);
    	fclose ($file);
    	?>
			<div id="message" class="updated fade"><p><?php _ge ('Your settings have been saved') ?></p></div>
  		<?php
  	  return true;
	  }
    else
		{
			?>
			<div id="message" class="error fade"><p><strong>Failed to save options file.  Is the theme directory write-enabled?</strong><br/><code><small><?php echo $options ?></small></code></p></div>
			<?php
		}
    	return false;
	}

	function get_skins ()
	{
		$items = array ();

		$skins = glob (ABSPATH.'wp-content/themes/giraffe2/skin/*', GLOB_ONLYDIR);
		if (count ($skins) > 0)
		{
			foreach ($skins AS $skin)
			{
				if (file_exists ($skin."/skin.css"))
				{
					$css = @file_get_contents ($skin."/skin.css");
	
					preg_match ('/Name: (.*)/', $css, $name);
					if (count ($name) > 0)
						$items[basename ($skin)] = $name[1];
				}
			}
		}

		return $items;
	}
}

function html_select ($arry, $current)
{
	if (count ($arry) > 0)
	{
		foreach ($arry AS $name => $text)
		{
			echo "<option value=\"$name\"";
			if ($current == $name)
				echo " selected=\"selected\"";
			echo ">$text</option>\r\n";
		}
	}
}

function giraffe_layout ()
{
	if (isset ($_POST['save_layout']))
	{
		G2_Admin::set_layout_from_post ();
		G2_Admin::save ();
	}

	$colours = array ();
	$columns = array ("1" => "1", "2" => "2", "3" => "3");
	$widths  = array ("800" => "800 pixels", "1024" => "1024 pixels", "65" => "65%", "75" => "75%", "85" => "85%", "95" => "95%", "100" => "100%");
	$cwidths = array ("0" => _g("Disabled"), "7.5" => "7.5%", "10" => "10.0%", "12.5" => "12.5%", "15" => "15.0%", "17.5" => "17.5%", "20" => "20.0%", "22.5" => "22.5%", "25" => "25.0%", "27.5" => "27.5%", "30" => "30.0%", "35" => "35.0%", "40" => "40.0%" );

	// Get skins and make a select-array
	$skins = G2_Admin::get_skins ();

	if (count ($skins) > 0)
	{
		foreach ($skins AS $key => $name)
			$colours[$key] = $name;
	}
?>
<div class="wrap">
  <h2><?php _ge('Layout')?> <?php echo GIRAFFE_VERSION ?></h2>
  <p><?php _ge ('You can change the general layout of your Giraffe2 theme by configuring the colour, size, and display settings.') ?></p>
  <p><?php _ge ('NOTE: The width of the columns are a percentage of the page width.  The main content area is the remainder of the page not used by the columns.') ?></p>

  <form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
	<table cellpadding="10">
		<tr>
			<td valign="top">
				<table cellspacing="0" cellpadding="0"  class="g2_options">
					<tr>
						<th><?php _ge ('Page width') ?>:</th>
						<td>
							<select name="width" id="width" onchange="update_image()"><?php html_select ($widths, G2C::get ('width')) ?></select>
						</td>
					</tr>
				  <tr>
				    <th><?php _ge ('Left column') ?>:</th>
				    <td>
				      <select id="width_left" name="width_left" onchange="update_image()"><?php html_select ($cwidths, G2C::get ('width_left')) ?></select>
				    </td>
				  </tr>
				  <tr>
				    <th><?php _ge ('Right column') ?>:</th>
				    <td>
				      <select id="width_right" name="width_right" onchange="update_image()"><?php html_select ($cwidths, G2C::get ('width_right')) ?></select>
				    </td>
				  </tr>
					<tr>
					  <th><?php _ge ('Colour') ?>:</th>
					  <td>
							<select name="colour" id="colour" onchange="update_image()"><?php html_select ($colours, G2C::get ('colour')) ?></select>
						</td>
					</tr>
				</table>
			</td>
			<td>
			  <div class="g2_pagelayout">
					<img alt="top" src="<?php G2_Admin::admin_link () ?>/browser_top.png"/>
					<div id="g2_layoutpic">
							<img alt="Page" id="layoutpic" style="width: <?php echo G2_Admin::get_width_percent () ?>" src="<?php bloginfo ('template_url') ?>/skin/<?php echo G2C::get ('colour') ?>/screenshot_<?php echo G2C::get ('width_left') > 0 ? "L" : "N" ?><?php echo G2C::get ('width_right') > 0 ? "R" : "N" ?>.png"/>
					</div>
				  <img alt="bottom" src="<?php G2_Admin::admin_link () ?>/browser_bottom.png"/>
			  </div>
			</td>
		</tr>
	</table>

  <p class="submit">
    <input type="submit" name="save_layout" value="<?php _ge('Update Options')?> &raquo;" />
  </p>
	<input type="hidden" id="base_cheat" name="base_cheat" value="<? bloginfo ('template_url') ?>/skin/"/>
	</form>

</div>
<?php
}

function giraffe_options ()
{
	$g2_fonts = array
	(
		"Arial, Sans-serif"                              => "Arial",
		"&quot;Arial Black&quot;, arial, sans-serif"     => "Arial Black",
		"&quot;Arial Narrow&quot;, arial, sans-serif"    => "Arial Narrow",
		"&quot;Century Gothic&quot;, Arial, sans-serif"  => "Century Gothic",
		"&quot;courier new&quot;, monospace"             => "Courier",
		"cursive"                                        => "Cursive",
		"fantasy"                                        => "Fantasy",
		"&quot;Lucida Grande&quot;, Arial, Sans-Serif"   => "Lucida Grande",
		"&quot;Trebuchet MS&quot;, Arial, Sans-Serif"    => "Trebuchet MS",
		"Tahoma, Arial, Sans-Serif"                      => "Tahoma",
		"Times, Serif"                                   => "Times New Roman",
		"Verdana, Arial, Sans-Serif"                     => "Verdana",
	);

	if (isset ($_POST['save_options']))
	{
		G2_Admin::set_options_from_post ();
		G2_Admin::save ();
	}

	$top_menu = array
	(
	  "off" => _g ("is disabled"),
	  "links" => _g ("contains links"),
		"bookmarks" => _g ('bookmarks from Menu category'),
	  "pages" => _g ("contains pages"),
	  "pageshome" => _g ('contains pages, with home'),
	  "categories" => _g ("contains categories"),
	  "custom" => _g ("is defined by the custom items below")
	);
?>
<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post">
<div class="wrap">
  <h2><?php _ge('Options')?> <?php echo GIRAFFE_VERSION ?></h2>

	<h3><?php _ge ('General') ?></h3>
	<table class="g2_options">
	  <tr>
	    <th><?php _ge ('Font') ?>:</th>
	    <td>
	    	<select name="font" id="font" onchange="change_font (this)" style="font-family: <?php echo G2C::get ('font') ?>">
					<?php html_select ($g2_fonts, G2C::get ('font')); ?>
				</select>
			</td>
	  </tr>
	  <tr>
	    <th><?php _ge ('Bar') ?>:</th>
	    <td><input name="bar" type="checkbox" <?php if (G2_Admin::has_a_bar ()) : ?>checked="checked"<?php endif; ?>/> (only allowed with single right column)</td>
	  </tr>
	  <tr>
	    <th><?php _ge ('Curved corners') ?>:</th>
	    <td><input name="corners" type="checkbox" <?php if (G2_Admin::has_corners ()) : ?>checked="checked"<?php endif; ?>/></td>
	  </tr>
	  <tr><th><label for="author"><?php _ge ('Show author'); ?>:</label></th><td><input type="checkbox" id="author" name="author"<?php if (G2C::get ('author') == "true") : ?>checked="checked"<?php endif; ?>/></td></tr>
	  <tr><th><label for="ajaxcomments"><?php _ge ('AJAX comments:'); ?></label></th><td><input type="checkbox" id="ajax_comments" name="ajax_comments"<?php if (G2C::get ('ajax_comments') == "true") : ?>checked="checked"<?php endif; ?>/></td></tr>
	</table>

	<h3><?php _ge('Post options')?></h3>
	<img width="100" height="112" style="float: left; margin-left: 30px" src="../wp-content/themes/giraffe2/admin/layoutposts.png" alt="layout2"/>
	<table>
	  <tr><td><?php _ge('Number of lead posts')?></td><td><input type="text" size="3" name="posts_lead" value="<?php echo G2C::get ('posts_lead') ?>"/></td></tr>
	  <tr><td><?php _ge('Number of recent posts')?></td><td><input type="text" size="3" name="posts_other" value="<?php echo G2C::get ('posts_other') ?>"/></td></tr>
	  <tr><td><?php _ge ('Full width single &amp; lead post') ?></td><td><input type="checkbox" name="lead_full"<?php if (G2C::get ('lead_full') == "true") : ?>checked="checked"<?php endif; ?>/></td></tr>
	</table>
	<div style="clear: both"></div>

	<h3><?php _ge ('Comments')?></h3>
	<img width="100" height="112" style="float: left; margin-left: 30px" src="../wp-content/themes/giraffe2/admin/layoutcomments.png" alt="layout2"/>
	<table>
	  <tr><td><?php _ge('Inset items:')?></td><td><input type="text" size="3" name="inset_count" value="<?php echo G2C::get ('inset_count') ?>"/> <em>(<?php _ge ('0 to disable')?>)</em></td>
	  <tr><td><?php _ge ('Comment order:')?></td>
	      <td>
	        <select name="comments_order">
	          <?php html_select (array ("asc" => _g ('Oldest first'), "desc" => _g ('Newest first')), G2C::get ('comments_order')) ?>
	        </select>
	      </td>
	  </tr>
	  <tr><td><?php _ge ('Enable Gravatars:')?></td><td><input type="checkbox" name="comments_gravatar"<?php if (G2C::get ('comments_gravatar') == "true") : ?>checked="checked"<?php endif; ?>/></td></tr>
	</table>
	<div style="clear: both"></div>

	<h3><?php _ge ('Top menu') ?></h3>
	<table>
		<tr>
			<td><?php _ge ('The top menu') ?></td><td>
			<select name="top_menu">
		  <?php html_select ($top_menu, G2C::get ('top_menu')) ?>
			</select>
			</td>
		</tr>
		<tr>
			<td valign="top"><?php _ge ('Custom items') ?></td>
			<td><textarea name="top_custom" cols="60" rows="3"><?php echo stripslashes (htmlentities (G2C::get ('top_custom'))) ?></textarea><br/>(each item must be surrounded by &lt;li&gt; &lt;/li&gt;)
			</td>
		</tr>
	</table>

	<h3><?php _ge ('Footer')?></h3>
	<textarea style="width: 80%" name="footer" cols="60" rows="5"><?php echo stripslashes (htmlentities (G2C::get ('footer'))) ?></textarea>

  <p class="submit">
    <input type="submit" name="save_options" value="<?php _ge('Update Options')?> &raquo;" />
    <input type="hidden" name="giraffe" value="giraffe"/>
  </p>
</div>
</form>
<?php
  }

function giraffe_logo ()
{
	if (isset ($_POST['save_logo']))
	{
		G2_Admin::set_logo_from_post ();
		G2_Admin::save ();
	}

$g2_fonts = array
(
	"Arial, Sans-serif"                              => "Arial",
	"&quot;Arial Black&quot;, arial, sans-serif"     => "Arial Black",
	"&quot;Arial Narrow&quot;, arial, sans-serif"    => "Arial Narrow",
	"&quot;Century Gothic&quot;, Arial, sans-serif"  => "Century Gothic",
	"&quot;courier new&quot;, monospace"             => "Courier",
	"cursive"                                        => "Cursive",
	"fantasy"                                        => "Fantasy",
	"&quot;Lucida Grande&quot;, Arial, Sans-Serif"   => "Lucida Grande",
	"&quot;Trebuchet MS&quot;, Arial, Sans-Serif"    => "Trebuchet MS",
	"Tahoma, Arial, Sans-Serif"                      => "Tahoma",
	"Times, Serif"                                   => "Times New Roman",
	"Verdana, Arial, Sans-Serif"                     => "Verdana",
);

$sizes = array
(
  "1.2em" => _g("Small"),
  "1.4em" => _g("Medium"),
  "1.6em" => _g("Large"),
  "1.8em" => _g("Larger"),
  "2em"   => _g("Ouch")
);

$align = array
(
  "no-repeat" => _g("No repeat"),
  "repeat-x"  => _g("Repeat X-axis only"),
  "repeat"    => _g("Full repeat")
);

$textalign = array
(
  "left"   => _g("Left"),
  "center" => _g("Centre"),
  "right"  => _g("Right"),
);

$units = array
(
  "em" => "em",
  "px" => _g("pixels")
);

$height = G2C::get ('logo_height');
if (G2C::get ('logo_height_units') == "px")
	$height += 2;
else
	$height += 2.4;

?>


<script language="JavaScript" type="text/javascript">
//<![CDATA[
function get_id ()
{
	return frames['demo'].document.getElementById ('header');
}

function change_font ()
{
	var fontstyle = $F('logo_font');
	var fontsize  = $F('logo_fontsize');
	var fontalign = $F('logo_textalign');

	var obj = get_id ();

	var items = obj.getElementsByTagName ('div');
	for (var i = 0; i < items.length; i++)
	{
		items[i].style.fontFamily = fontstyle;
		items[i].style.textAlign  = fontalign;
	}

	obj.style.fontSize = fontsize;
}

function change_height ()
{
	var obj = get_id ();
	var units = $F('logo_height_units');

	// Find gradientheader
  obj.style.height = $F('logo_height') + units;

	// Also resize the iframe
	$('demo').style.height = Element.getHeight (obj) + "px";
}

function change_logo (field, img)
{
  var grad = frames['demo'].document.getElementById ('headerimg');
	if (img)
		grad.style.backgroundImage = "url(../wp-content/themes/giraffe2/" + img + ")";
	grad.style.backgroundPosition = $F('logo_align') + " top";
	grad.style.backgroundRepeat = "no-repeat";
}

function change_pattern (field, img)
{
  var grad = frames['demo'].document.getElementById ('header');

	if (img)
		grad.style.backgroundImage = "url(../wp-content/themes/giraffe2/" + img + ")";

	grad.style.backgroundRepeat = $F('logo_repeat');
}

function change_background (field, img)
{
	var bk = frames['demo'].document.body;

	if (img)
		bk.style.backgroundImage = "url(../wp-content/themes/giraffe2/" + img + ")";
	bk.style.backgroundRepeat = $F('logo_background_repeat');
}

function change_titles ()
{
  var grad = frames['demo'].document.getElementById ('headerimg');
  var h1   = grad.getElementsByTagName ('h1');
  var div  = grad.getElementsByTagName ('div');

  if (h1.length == 0 || div.length == 0)
  {
		grad.innerHTML = '<h1><a href=\"<?php echo get_settings('wpurl'); ?>\"><?php echo bloginfo('name'); ?><\/a><\/h1><div class=\"description\"><?php bloginfo('description'); ?><\/div>';
		h1 = grad.getElementsByTagName ('h1');
  }

  if ($F('logo_title'))
  	h1[0].style.display = '';
 	else
 		h1[0].style.display = 'none';

  if ($F('logo_tagline'))
  	div[0].style.display = '';
 	else
 		div[0].style.display = 'none';
}

function image_deselect (item)
{
	var selected = document.getElementsByClassName ('g2_image_selected', item.parentNode);

  for (var i = 0; i < selected.length; i++)
    selected[i].className = "";
}

function image_select (item, file, field)
{
  image_deselect (item);
  item.className = "g2_image_selected";

  // Now update the select
  var sel = item.parentNode.parentNode;

  sel = $("select_" + sel.id);
  sel.value = file;
}

function image_change (item, field)
{
  var tmp = item.options[item.selectedIndex].text;
  image_deselect (item);

  if (item.value)
  {
	  var change = $(field + "_" + tmp);
	  if (change)
	  {
			change.className = "g2_image_selected";
			change.scrollIntoView ();
		}
	}
}

function g2_font_select (item)
{
  var sib = item.nextSibling.nextSibling;
  if (sib)
  	sib.style.fontFamily = item.value;
}

function g2_image_drop (id, item)
{
	var remember = item.onclick;
	Effect.toggle (id, 'blind', { duration: 0.5, afterFinish : function(effect) { item.innerHTML = ($(id).style.display == 'none') ? '&dArr;' : '&uArr;'; item.onclick = remember;}});
}

//]]>
</script>

<div class="wrap">
<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post" enctype="multipart/form-data">
<iframe name="demo" id="demo" style="padding: 0; background-color: white; height: <?php echo $height.G2C::get ('logo_height_units') ?>" scrolling="no" src="<?php bloginfo ('home') ?>" class="g2_demo">
Eeek, get a better browser!
</iframe>

<h3><?php _ge ('Text') ?></h3>
<table class="g2_options">
	<colgroup width="120"/>
	<tr>
		<th><?php _ge ('Height') ?>:</th>
		<td>
		  <input type="text" onchange="change_height()" id="logo_height" name="logo_height" value="<?php echo G2C::get ('logo_height') ?>" size="5"/>
		  <select id="logo_height_units" name="logo_height_units" onchange="change_height()">
		  <?php html_select ($units, G2C::get ('logo_height_units')) ?></select>
		</td>
	</tr>
	<tr>
		<th valign="top"><?php _ge ('Font') ?>:</th>
		<td>
			<select name="logo_font" id="logo_font" onchange="change_font ();  change_height ()">
			<?php html_select ($g2_fonts, G2C::get ('logo_font')); ?>
			</select>
			<?php _ge ('size') ?>:
		  <select name="logo_fontsize" id="logo_fontsize" onchange="change_font (); change_height ()">
		  <?php html_select ($sizes, G2C::get ('logo_fontsize')) ?>
		  </select>
		  <?php _ge ('alignment') ?>:
		  <select name="logo_textalign" id="logo_textalign" onchange="change_font ()">
	    <?php html_select ($textalign, G2C::get ('logo_textalign')) ?>
	    </select>
		</td>
	</tr>
	<tr>
	  <th><?php _ge ('Show title') ?>:</th><td><input type="checkbox" id="logo_title" name="logo_title" onchange="change_titles()" <?php if (G2C::get ('logo_title') == "true") : ?>checked="checked"<?php endif; ?>/>
	  </td>
	</tr>
	<tr>
	  <th><?php _ge ('Show tagline') ?>:</th><td><input type="checkbox" id="logo_tagline" name="logo_tagline" onchange="change_titles()" <?php if (G2C::get ('logo_tagline') == "true") : ?>checked="checked"<?php endif; ?>/>
	  </td>
	</tr>
</table>

<h3><?php _ge ('Logo') ?></h3>
<table class="g2_options">
	<colgroup width="120"/>
	<tr>
	  <th valign="top"><?php _ge ('Logo') ?>:</th>
	  <td><?php html_image_browser ('logo_image', 'logo', G2C::get ('logo_image'), 'change_logo') ?>
	  </td>
	</tr>
	<tr>
	  <th valign="top"><?php _ge ('Logo position') ?>:</th>
	  <td><select name="logo_align" id="logo_align" onchange="change_logo ('logo_align', null)">
	    <?php html_select ($textalign, G2C::get ('logo_align')) ?>
	    </select></td>
	</tr>
</table>

<h3><?php _ge ('Logo background') ?></h3>
<table class="g2_options">
	<colgroup width="120"/>
	<tr>
	  <th valign="top"><?php _ge ('Pattern') ?>:</th>
	  <td><?php html_image_browser ('logo_gradient', 'gradient', G2C::get ('logo_gradient'), 'change_pattern') ?></td>
	</tr>
	<tr>
	  <th><?php _ge ('Repeat') ?>:</th>
	  <td><select name="logo_repeat" id="logo_repeat" onchange="change_pattern('',null)">
	       <?php html_select ($align, G2C::get ('logo_repeat')) ?>
	      </select>
	  </td>
	</tr>
</table>

<h3><?php _ge ('Page background') ?></h3>
<table class="g2_options">
	<colgroup width="120"/>
	<tr>
	  <th valign="top"><?php _ge ('Pattern') ?>:</th>
	  <td><?php html_image_browser ('logo_background', 'background', G2C::get ('logo_background'), 'change_background') ?></td>
	</tr>
	<tr>
	  <th><?php _ge ('Repeat') ?>:</th>
	  <td><select name="logo_background_repeat" id="logo_background_repeat" onchange="change_background('',null)">
	       <?php html_select ($align, G2C::get ('logo_background_repeat')) ?>
	      </select>
	  </td>
	</tr>
</table>

  <p class="submit">
    <input type="submit" name="save_logo" value="<?php _ge('Update Options')?> &raquo;" />
  </p>
  </form>
</div>
<?php
}

	function html_image_browser ($fieldname, $targetdir, $current, $clicker = null)
	{
		$allowed_files = "{*.png,*.jpg,*.jpeg,*.gif}";

		// Load all jpg/png/gif images in the standard directory
		$dir = ABSPATH."wp-content/themes/giraffe2/$targetdir/";

		// Get all jpeg/jpg/gif/png images in standard directory
		$files  = glob ($dir.$allowed_files, GLOB_BRACE);
		$images = $thumbs = $sizes = array ();

		$images[""] = _g ("-- no image --");

		sort ($files);

		if (!$clicker)
			$clicker = "image_change_preview";

		if (count ($files) > 0)
		{
			// Now process it properly
			foreach ($files AS $file)
			{
				if (substr ($file, -9, 9) != "thumb.png")
				{
					$key = "$targetdir/".basename ($file);

					$images[$key] = basename ($file);

					$parts = explode ('.', basename ($file));
					unset ($parts[count ($parts) - 1]);

					$thumbnail = implode ('.', $parts)."_thumb.png";
					if (file_exists ($dir.$thumbnail) || resize ($file, $dir.$thumbnail, 100, 100, false))
					{
						$thumbs[$key] = "$targetdir/$thumbnail";
						$size = getimagesize ($dir.$thumbnail);
					}
					else
					{
						$thumbs[$key] = $key;
						$size = getimagesize ($file);
					}

			    $scale  = min (100 / $size[0], 100 / $size[1]);
			    if ($scale < 1)
			    {
			      $size[0] = floor ($scale * $size[0]);
			      $size[1] = floor ($scale * $size[1]);
			    }

					$sizes[$key] = 'width="'.$size[0].'" height="'.$size[1].'"';

					if ($key == $current)
					{
						$current_thumb = $thumbs[$key];
						$current_name  = basename ($file);
					}
				}
			}
		}

		// Because I can't figure out why the drop-down isnt working in IE		
		$ie = false;
		if (strstr ($_SERVER['HTTP_USER_AGENT'], "MSIE"))
			$ie = true;
?>
<?php if (count ($images) > 0) : ?>
	<select id="select_<?php echo $fieldname ?>" name="<?php echo $fieldname ?>" onchange="image_change(this,'<?php echo $fieldname ?>'); <?php echo $clicker ?>('<?php echo $fieldname ?>',this.value)">
	  <?php	html_select ($images, $current) ?>
	</select>
<?php if (!$ie) : ?><a href="#" onclick="g2_image_drop ('<?php echo $fieldname ?>', this); return false">&dArr;</a><?php endif; ?>
<?php else : ?>
  <select disabled="disabled"><option><?php _ge ('--No images--') ?></option></select><input type="hidden" name="<?php echo $fieldname?>" value=""/>
<?php endif; ?>
	<?php _ge ('Upload') ?>: <input type="file" name="<?php echo $targetdir ?>"/>

<?php if (!$ie) : ?>
  <div class="g2_image_browser" id="<?php echo $fieldname ?>" style="display: none;position: relative">
	  <ul style="width: <?php echo (count ($thumbs) * 132) + 10 ?>px" id="image_browser_<?php echo $fieldname ?>">
	  <?php foreach ($images AS $file => $name) : ?>
	  <?php if ($file) : ?>
		  <li<?php if ($current == $file) :?> class="g2_image_selected"<?php endif; ?> ondblclick="Effect.toggle ('<?php echo $fieldname ?>', 'slide', { duration: 0.5 })" onclick="image_select (this,'<?php echo $file ?>','<?php echo $fieldname ?>'); <?php echo $clicker ?>('<?php echo $fieldname ?>','<?php echo $file ?>')" id="<?php echo $fieldname."_".$name ?>">
		  <img src="<?php echo get_bloginfo ('template_url')."/".$thumbs[$file] ?>" alt="<?php echo $name ?>" <?php echo $sizes[$file] ?>/><br/>
		  <div class="g2_image_info"><?php echo $name ?></div>
		  </li>
		<?php endif; ?>
	  <?php endforeach; ?>
	  </ul>
	  <div style="clear: both"></div>
	</div>
<?php endif; ?>
  <div style="clear: both"></div>
	  <?php
	}

	function html_fonts ($class, $current)
	{
		global $G2_FONTS;

		echo '<select name="'.$class.'" onchange="g2_font_select(this)">';
		G2_Utility::html_select ($G2_FONTS, $current);
		echo '</select> <span class="g2_font_select">The quick brown fox jumped over the lazy dog.</span>';
	}

	function escape ($str)
	{
		if (get_magic_quotes_gpc())
			$str = stripslashes ($str);
		return mysql_real_escape_string ($str);
	}

	/**
	 * Resizes an image
	 * @param string src Source filename
	 * @param string target Target filename
	 * @param int width Maximum width
	 * @param int height Maximum height
	 */
	function resize ($src, $target, $maxwidth, $maxheight, $deletesrc = true)
	{
	  // Now resize it
	  $img = null;
	  $ext = strtolower (end (explode ('.', $src)));
	  if ($ext == 'jpg' || $ext == 'jpeg')
	    $img = @imagecreatefromjpeg ($src);
	  else if ($ext == 'png')
	    $img = @imagecreatefrompng ($src);
	  else if ($ext == 'gif')
	  	$img = @imagecreatefromgif ($src);

	  if ($img)
	  {
	    // Get image size and scale ratio
	    $width  = imagesx ($img);
	    $height = imagesy ($img);
	    $scale  = min ($maxwidth / $width, $maxheight / $height);

	    // If the image is larger than the max shrink it
	   // if ($scale < 1)
	    {
	      $new_width  = floor ($scale * $width);
	      $new_height = floor ($scale * $height);

				if ($new_width == 0)
					$new_width = 1;
				if ($new_height == 0)
					$new_height = 1;

	      // Create a new temporary image
	      $tmp_img = imagecreatetruecolor ($new_width, $new_height);
	      $tmp_trans = imagecreatetruecolor ($width, $height);

	      imagefill ($tmp_trans, 0, 0, imagecolorallocate ($tmp_img, 255, 255, 255));

				imagecolortransparent ($tmp_img, imagecolorallocate ($tmp_img, 255, 255, 255));
				imagecolortransparent ($img, imagecolorallocate ($img, 255, 255, 255));

	      // Copy and resize old image into new image
	      imagecopymerge ($tmp_trans, $img, 0, 0, 0, 0, $width, $height, 100);
		    imagecopyresized ($tmp_img, $tmp_trans, 0, 0, 0, 0, $new_width, $new_height, $width, $height);

	      imagedestroy ($img);
	      imagedestroy ($tmp_trans);

	      $img = $tmp_img;
	    }

	    if (@imagepng ($img, $target) && ($deletesrc == false || unlink ($src)))
	    	return true;
	  }
	  return false;
	}


	function safe_filename ($name)
	{
		$noalpha = '@';
		$alpha   = 'AEIOUYaeiouyAEIOUaeiouAEIOUaeiouAEIOUaeiouyAaOoAaNnCcaooa';

		$name = substr ($name, 0, 250);
		$name = strtr  ($name, $noalpha, $alpha);

		$name = str_replace (' ', '_', $name);   // Because it cauess problems in CSS
		$name = strtolower ($name);

		// not permitted chars are replaced with "_"
		return preg_replace('/[^a-zA-Z0-9,._\+\()\-]/', '-', $name);
	}

	function makedir ($dir)
	{
	  if (is_null ($dir) || $dir === "" )
	    return false;

	  if (is_dir ($dir) || $dir === "/" || $dir == "\\")
	    return true;

	  if (G2_Utility::makedir (dirname ($dir)))
	    return mkdir ($dir);
	  return false;
	}

	function file_uploads ($files)
	{
		if (count ($files) > 0)
		{
			// All uploaded files go to theme directory
			foreach ($files AS $field => $upload)
			{
				if ($files[$field]['tmp_name'])
				{
					$target_dir = ABSPATH."/wp-content/themes/giraffe2/";
					$target_dir .= safe_filename ($field)."/";

					if (is_uploaded_file ($files[$field]['tmp_name']))
					{
						if (move_uploaded_file ($files[$field]['tmp_name'], $target_dir.safe_filename ($files[$field]['name'])))
						{
							$path = dirname ($field)."/";
							$file = safe_filename ($files[$field]['name']);
							$dir  = ABSPATH."/wp-content/themes/giraffe2/";

							$parts = explode ('.', $file);
							unset ($parts[count ($parts) - 1]);

							$thumbnail = implode ('.', $parts)."_thumb.png";

							// Create a thumbnail
							resize ($dir.$path.$file, $dir.$path.$thumbnail, 100, 100, false);
						}
					}
				}
			}
		}
	}
?>