<?php

define (GIRAFFE_VERSION, '2.0 wonky 4');

if (!function_exists ('load_theme_textdomain'))
  include (ABSPATH.WPINC.'/wp-l10n.php');

load_theme_textdomain ('giraffe');

// Register ourself with the widget master
if (function_exists ('register_sidebar'))
{
  register_sidebar (array ("name" => _g('Left column')));
  register_sidebar (array ("name" => _g('Right column')));
  register_sidebar_widget (_g('Post Summary'), 'giraffe_post_summary');
}

function giraffe_post_summary ($args)
{
  global $post, $user_ID;
  extract($args);

  if (is_single () || is_page ())
  {
  ?>
		<?php echo $before_widget; ?>
	    <h2><?php _ge('Information')?></h2>
			<dl>
			<?php if ($post->post_date != $post->post_modified) { ?>
			<dt><img alt="modified" src="<?php G2::image ()?>/info_created.png"/><?php _ge('Modified')?></dt><dd><?php printf (_g('%1$s at %2$s'),  mysql2date (_g('F jS, Y'), $post->post_modified), mysql2date (_g('H:i'), $post->post_modified)); ?></dd>
		  <?php } else { ?>
			<dt><img alt="created" src="<?php G2::image ()?>/info_created.png"/><?php _ge('Created')?></dt><dd><?php printf (_g('%1$s at %2$s'), mysql2date (_g('F jS, Y'), $post->post_date), mysql2date (_g('H:i'), $post->post_date)); ?></dd>
      <?php } ?>
			<?php if ($post->ping_status === 'open') : ?>
			<dt><img alt="trackback" src="<?php G2::image ()?>/info_trackback.png"/><a href="<?php trackback_url (true) ?>"><?php _ge('Trackback')?></a></dt><dd><?php _ge('Link from your site')?></dd>
			<?php endif; ?>
      <dt><img alt="rss" src="<?php G2::image ();?>/info_rss.png"/><?php comments_rss_link ('RSS 2.0') ?></dt><dd><?php _ge('Subscribe to comments')?></dd>
      <?php global $user_ID, $post;
            get_currentuserinfo();
          	if (user_can_edit_post($user_ID, $post->ID)) : ?>
			<dt><img alt="edit" src="<?php G2::image ()?>/info_edit.png"/><a href="<?php echo get_settings('siteurl') . "/wp-admin/post.php?action=edit&amp;post=$post->ID"; ?>"><?php _ge('Edit this')?></a></dt><dd><?php _ge('Only for authors')?></dd>
			<?php endif; ?>
			</dl>
		<?php echo $after_widget; ?>
  <?php
  }
  else if (is_category()) { ?>
		<?php echo $before_widget; ?><h2><?php _ge('Information')?></h2><p><?php printf(_g('You are currently browsing the archives for the %s category.'), single_cat_title ('', false)) ?></p><?php echo $after_widget; ?>

	<?php } elseif (is_day()) { ?>
		<?php echo $before_widget; ?><h2><?php _ge('Information')?></h2><p><?php printf(_g('You are currently browsing the %s weblog archives for'), '<a href="'.get_settings('siteurl').'">'.get_bloginfo('name').'</a>')?> <?php the_time(_g('l, F jS, Y'))?>.</p><?php echo $after_widget; ?>

		<?php } elseif (is_month()) { ?>
		<?php echo $before_widget; ?><h2><?php _ge('Information')?></h2><p><?php printf(_g('You are currently browsing the %s weblog archives for'), '<a href="'.get_settings('siteurl').'">'.get_bloginfo('name').'</a>')?> <?php the_time(_g('F, Y')); ?>.</p><?php echo $after_widget; ?>

    <?php  } elseif (is_year() && !is_404 ()) { ?>
		<?php echo $before_widget; ?><h2><?php _ge('Information')?></h2><p><?php printf(_g('You are currently browsing the %s weblog archives for'), '<a href="'.get_settings('siteurl').'">'.get_bloginfo('name').'</a>')?> <?php the_time(_g('Y')); ?>.</p><?php echo $after_widget; ?>

	 <?php  } elseif (is_search()) { ?>
		<?php echo $before_widget; ?><h2><?php _ge('Information')?></h2><p><?php printf(_g('You have searched the %1$s weblog archives for <strong>%2$s</strong>. If you are unable to find anything in these search results, you can try one of the archive links.'), '<a href="'.get_settings('siteurl').'">'.get_bloginfo('name').'</a>', wp_specialchars($s))?></p><?php echo $after_widget; ?>

		<?php } elseif (isset($_GET['paged']) && !empty($_GET['paged'])) { ?>
	<?php echo $before_widget; ?><h2><?php _ge('Information')?></h2><p><?php printf(_g('You are currently browsing the %s weblog archives.'),'<a href="'.get_settings('siteurl').'">'.get_bloginfo('name').'</a>')?></p><?php echo $after_widget; ?>

		<?php }
}

function widget_giraffe_search ($args)
{
	extract($args);
?>
		<?php echo $before_widget; ?>
		  <h2>Search</h2>
			<form method="get" id="searchform" action="<?php echo $_SERVER['PHP_SELF']; ?>">
<div><input alt="Search" type="text" value="<?php echo wp_specialchars($s, 1); ?>" name="s" id="s" />
<input type="submit" id="searchsubmit" value="<?php _ge('Go')?>" />
</div>
</form>
		<?php echo $after_widget; ?>
<?php
}


function widget_giraffe_ajax ($args)
{
	if (function_exists ('ajax_calendar'))
	{
	extract($args);
?>
		<?php echo $before_widget; ?>
    <?php ajax_calendar (); ?>
		<?php echo $after_widget; ?>
<?php
	}
}

function widget_giraffe_recent ($args) {
	extract($args);
	$title = __('Recent Posts');

		global $posts, $post, $id;
		$backup_posts = $posts;
		$backup_post = $post;

		// Get post, assigning it to global variables
	$r = new WP_Query('showposts=10');
	if ($r->have_posts()) :
?>
		<?php echo $before_widget; ?>
			<?php echo $before_title . $title . $after_title; ?>
			<ul>
			<?php  while ($r->have_posts()) : $r->the_post(); ?>
			<li><a href="<?php the_permalink() ?>"><?php if ( get_the_title() ) the_title(); else the_ID(); ?> </a></li>
			<?php endwhile; ?>
			</ul>
		<?php echo $after_widget; ?>
<?php
	$posts = $backup_posts; $post = $backup_post;

	endif;
}

function giraffe_locale_menu ($args)
{
	extract($args);

  $ldir = opendir (ABSPATH.'/wp-content/themes/giraffe2/');
  while (($file = readdir ($ldir)) !== false)
  {
    $ext = substr (strrchr ($file, "."), 1);
    if ($ext == 'mo' && $file != "giraffe.mo")
      $molist[] = substr ($file, 0, strlen ($file) - 3);
  }

  closedir ($ldir);

  if (count ($molist) > 0)
  {
    $giraffe_locale = array
    (
      "it_IT" => 'Italiano',
      "zh_CN" => '雅虎中国',
      "es_ES" => 'Español',
      "de_DE" => 'Deutsch',
      "el_SX" => 'Greek',
      "ja"    => 'Japanese',
      "nn_NO" => "Nynorsk",
      "nl_NL" => "Dutch"
    );

    echo $before_widget; ?>
  <h2><?php _ge ('Localization') ?></h2>
  <form method="get" action="<?php bloginfo ('home') ?>" style="padding: 1em">
    <select name="lang">
      <option value="">English</option>
      <?php foreach ($molist AS $mo) : ?>
      <option value="<?php echo $mo ?>"><?php if (isset ($giraffe_locale[$mo])) echo $giraffe_locale[$mo]; else echo $mo; ?></option>
      <?php endforeach; ?>
    </select>
    <input type="submit" style="border: 1px solid #999;" value="<?php _ge('Go')?>"/>
  </form>
<?php echo $after_widget;
  }
}


if (function_exists ('register_sidebar_widget'))
{
  register_sidebar_widget (_g('Search'), 'widget_giraffe_search');
  register_sidebar_widget (_g('Recent Posts'), 'widget_giraffe_recent');
  register_sidebar_widget (_g('Locale Menu'), 'giraffe_locale_menu');
  if (function_exists ('widget_giraffe_ajax'))
    register_sidebar_widget (_g('AJAX Calendar'), 'widget_giraffe_ajax');
}


// Define some functions in case user's PHP is pretty old
if (!function_exists ("mysql_real_escape_string"))
{
  function mysql_real_escape_string ($str)
  {
    return mysql_escape_string ($str);
  }
}

if (!function_exists('file_get_contents'))
{
  function file_get_contents($filename, $incpath = false, $resource_context = null)
  {
    if (false === $fh = fopen($filename, 'rb', $incpath)) {
        return false;
    }

    clearstatcache();
    if ($fsize = @filesize($filename)) {
        $data = fread($fh, $fsize);
    } else {
        $data = '';
        while (!feof($fh)) {
            $data .= fread($fh, 8192);
        }
    }

    fclose($fh);
    return $data;
  }
}


/**
 * Now for the Giraffe stuff
 */
function _g($str)
{
  return __($str, 'giraffe');
}

function _ge($str)
{
  _e($str, 'giraffe');
}

/** Now we define the configuration class and one instance
 */

$G2_Config = array ();
$giraffe_lead = 0;
$giraffe_recent = 0;

class G2C
{
	function G2C ()
	{
		global $G2_Config;

		// Set defaults
		$G2_Config['width']   = 85;
		$G2_Config['font']    = 'arial';
		$G2_Config['colour']  = 'blue';
		$G2_Config['bar']     = 'true';
		$G2_Config['corners'] = 'true';
		$G2_Config['author'] = 'false';
		$G2_Config['posts_lead'] = 1;
		$G2_Config['posts_other'] = 3;
		$G2_Config['width_left'] = 0;
		$G2_Config['width_right'] = 20;
		$G2_Config['inset_count'] = 4;
		$G2_Config['logo_height_units'] = "em";
		$G2_Config['logo_height'] = 8;
		$G2_Config['logo_font'] = "arial";
		$G2_Config['logo_fontsize'] = "1.4em";
		$G2_Config['logo_textalign'] = "center";
		$G2_Config['logo_align'] = "left";
		$G2_Config['logo_image'] = "logo/giraffe.gif";
		$G2_Config['logo_gradient'] = "gradient/blue.png";
		$G2_Config['logo_repeat'] = "repeat-x";
		$G2_Config['logo_background'] = "background/blue_diagonal.png";
		$G2_Config['logo_background_repeat'] = "repeat";
		$G2_Config['logo_tagline'] = "true";
		$G2_Config['logo_title'] = "true";
		$G2_Config['ajax_comments'] = "true";

		$G2_Config['posts_other_excerpt'] = "false";
		$G2_Config['comments_gravatar'] = "true";
		$G2_Config['comments_recent'] = 3;
		$G2_Config['comments_order'] = "asc";
		$G2_Config['lead_full'] = "true";
		$G2_Config['top_menu'] = "pages";
		$G2_Config['top_custom'] = '<li><a href="http://www.cheese.com">example</a></li>';
		$G2_Config['footer'] = '<p>&copy; '.date ('Y').' Your name here</p>';

		// Load all config
		$cfg = get_option ('g2_config');
		if ($cfg)
		{
			$items = explode (';', $cfg);
			foreach ($items AS $item)
			{
				$parts = explode ('=', $item);
				$G2_Config[$parts[0]] = htmlentities (stripslashes ($parts[1]));
			}
		}

		if (get_option ('g2_footer'))
			$G2_Config['footer'] = get_option ('g2_footer');
		if (get_option ('g2_top_custom'))
			$G2_Config['top_custom'] = get_option ('g2_top_custom');
	}

	function get ($var)
	{
		global $G2_Config;
		if (isset ($G2_Config[$var]))
			return $G2_Config[$var];
		return "";
	}

	function set_footer ($value)
	{
		$custom = stripslashes ($custom);
		$G2_Config['footer'] = $value;
		update_option ('g2_footer', $value);
	}

	function set_top_custom ($custom)
	{
		$custom = stripslashes ($custom);
		$G2_Config['top_custom'] = $custom;
		update_option ('g2_top_custom', $custom);
	}

	function set ($name, $value)
	{
		global $G2_Config;
		$G2_Config[$name] = $value;
	}

	function set_check ($varname)
	{
		if (isset ($_POST[$varname]))
			G2C::set ($varname, "true");
		else
			G2C::set ($varname, "false");
	}

	function save ()
	{
		global $G2_Config;
		$str = "";
		foreach ($G2_Config AS $key => $value)
		{
			if ($key != 'footer' && $key != 'top_custom')
				$str .= "$key=$value;";
		}

		// Only allow bar on right column
		if (G2C::get ('width_left') == 0 && G2C::get ('width_right') != 0 && $G2_Config['bar'] == 'true')
			$G2_Config['bar'] = 'true';
		else
			$G2_Config['bar'] = 'false';

		update_option ('g2_config',  $str);
	//	update_option ('g2_footer', $G2_Config['footer']);
//		update_option ('g2_top_custom', $G2_Config['top_custom']);
	}
}

$G2C = new G2C;


/**
 * If we're in the admin section, then show the admin pages
 */
if (is_admin () && strstr ($_SERVER['REQUEST_URI'], 'themes.php'))
{
	function giraffe_add_options ()
	{
	  include ('../wp-content/themes/giraffe2/admin/admin.php');

	  add_theme_page(_g ('Giraffe Theme Layout'),  _g ('Layout'),  'edit_themes', 'admin.php',  'giraffe_layout');
	  add_theme_page(_g ('Giraffe Theme Options'), _g ('Options'), 'edit_themes', 'admin2.php', 'giraffe_options');
	  add_theme_page(_g ('Giraffe Theme Options'), _g ('Logo'),    'edit_themes', 'admin3.php', 'giraffe_logo');
	}

	function giraffe_add_head ()
	{
	?>
	<link rel="stylesheet" href="../wp-content/themes/giraffe2/admin/admin.css" type="text/css"/>
	<script language="JavaScript" type="text/javascript" src="<?php bloginfo ('wpurl') ?>/wp-content/themes/giraffe2/admin/admin.js"></script>
	<script language="JavaScript" type="text/javascript" src="<?php bloginfo ('wpurl') ?>/wp-content/themes/giraffe2/js/prototype.js.php"></script>
	<script language="JavaScript" type="text/javascript" src="<?php bloginfo ('wpurl') ?>/wp-content/themes/giraffe2/js/scriptaculous.js"></script>
	<?php
	}

	add_action ('admin_menu', 'giraffe_add_options');
	add_action ('admin_head', 'giraffe_add_head');
}
else
{
	/**
	 * Else we define the theme stuff
	 */
	class G2
	{
		function lead_full_width ()
		{
			if (G2C::get ('lead_full') == "true")
				return true;
			return false;
		}

		function has_left_column ()
		{
			if (G2C::get ('width_left') == 0)
				return false;
			return true;
		}

		function has_right_column ()
		{
			if (G2C::get ('width_right') == 0)
				return false;
			return true;
		}

    function has_inset_random_posts ()
    {
      if (G2C::get ('inset_count') > 0)
        return true;
      return false;
    }

    function have_ajax_comments ()
    {
      if (G2C::get ('ajax_comments') == "true")
        return true;
      return false;
    }

    function inset_random_posts ()
    {
      global $wpdb;

      $sql = "SELECT * FROM $wpdb->posts WHERE post_date <= now() AND (post_status = 'publish' OR post_status = 'sticky') AND post_password = ''";
      $sql .= " GROUP BY ID ORDER BY rand() DESC LIMIT 0, ";
      $sql .= G2C::get ('inset_count');
      $items = $wpdb->get_results ($sql);

      if ($items)
      {
        global $post;
        $remember = $post;
        foreach ($items AS $post)
        {
          echo "<li>".mysql2date(_g('d/m/Y'), $post->post_date).": ".'<a href="'.get_permalink().'">'.$post->post_title.'</a></li>';
        }

        $post = $remember;
      }
    }

		function has_inset_comments ()
		{
		  if (G2C::get ('inset_count') > 0)
		  {
		    global $wpdb;

		    $comments = $wpdb->get_row ("SELECT count(comment_author) FROM $wpdb->comments WHERE comment_approved='1'", ARRAY_N);
		    if ($comments[0] > 0)
		      return true;
		  }
		  return false;
		}

		function inset_comments ()
		{
		  global $wpdb;

		  $comments = $wpdb->get_results ("SELECT comment_ID, comment_author, comment_author_url, comment_post_ID, LEFT(comment_content, 100) AS comment_content, post_title FROM $wpdb->comments LEFT JOIN $wpdb->posts ON $wpdb->posts.ID=$wpdb->comments.comment_post_ID WHERE comment_type = '' AND comment_approved = '1' ORDER BY comment_date DESC LIMIT ".G2C::get ('inset_count'));
		  if ($comments)
		  {
		    foreach ($comments as $comment)
		    {
		      echo '<li>';
		      if ($comment->comment_author_url)
		        echo '<a class="author" title="'._g('Visit the author').'" href="'.$comment->comment_author_url.'">'.$comment->comment_author.'</a>';
		      else
		        echo $comment->comment_author;

		      echo ' '._g('commented on').' <a title="'._g('View the post').'" href="'.get_permalink ($comment->comment_post_ID).'">'.$comment->post_title.'</a><br/>';
		      echo '<em>"'.strip_tags ($comment->comment_content).'..."</em></li>';
		    }
		  }
		}

		function have_blog_title ()
		{
		  if (G2C::get ('logo_title') == "true")
		    return true;
		  return false;
		}

		function have_blog_tagline ()
		{
		  if (G2C::get ('logo_tagline') == "true")
		    return true;
		  return false;
		}

		function have_lead ()
		{
		  global $giraffe_lead;
		  if (G2C::get ('posts_lead') != $giraffe_lead++)
		    return true;
		  return false;
		}

		function have_recent ()
		{
		  global $giraffe_recent;
		  if (G2C::get ('posts_other') != $giraffe_recent++)
		    return true;
		  return false;
		}

		function last_recent ()
		{
		  global $giraffe_recent;
		  if (G2C::get ('posts_other') == $giraffe_recent)
		    return true;
		  return false;
		}

		function time ()
		{
		  return apply_filters('the_time', get_the_time( _g('F jS, Y') ), _g('F jS, Y'));
		}

		function image ()
		{
		  echo get_bloginfo ('template_url')."/skin/".G2C::get ('colour');
		}

		function html_lead ()
		{
			?>
<div id="lead" class="widecontent">
<?php while (have_posts () && G2::have_lead ()): the_post (); ?>
	<div class="post" id="post-<?php the_ID(); ?>">
		<h2><a href="<?php the_permalink() ?>" rel="bookmark" title="<?php _ge('Read full post')?>"><?php the_title(); ?></a></h2>
		<p class="postmetadata">
		  <small>
		    <?php echo G2::time () ?> |
		    <?php echo get_the_category_list(', '); ?> | <?php G2::html_author () ?>
		    <?php comments_popup_link (_g('No comments'), _g('1 comment'), _g('% comments')); ?>.
		  </small></p>

		<div class="entry">
					<?php the_content(_g('more')); ?>
		</div>
		<div class="clear"></div>
	</div>
<?php endwhile; ?>
</div>
			<?php
		}


    function html_author ()
    {
      if (G2C::get ('author') == "true")
      {
        the_author_posts_link ();
        echo " | ";
      }
    }

		function html_top_menu ()
		{
			if (G2C::get ('top_menu') == "bookmarks" && function_exists ('get_bookmarks')) : ?>
<div id="pagenav">
 <ul><?php $bookmarks = get_bookmarks ('category_name=Menu&orderby=rating'); 
					 foreach ($bookmarks AS $link)
							echo '<li class="page_item"><a href="'.$link->link_url.'" title="'.htmlspecialchars ($link->link_description).'">'.htmlspecialchars ($link->link_name).'</a></li>';
?></ul>
</div>
			<?php elseif (G2C::get ('top_menu') == "pages") : ?>
<div id="pagenav">
  <ul><?php wp_list_pages ('title_li=&depth=1&category_name=Top Menu'); ?></ul>
</div>
      <?php elseif (G2C::get ('top_menu') == 'pageshome') : ?>
<div id="pagenav">
  <ul><li><a href="<?php bloginfo ('home') ?>">Home</a></li><?php wp_list_pages ('title_li=&depth=1'); ?></ul>
</div>
      <?php elseif (G2C::get ('top_menu') == "links") : ?>
<div id="pagenav">
  <ul><?php get_links (-1, '<li>', '</li>', '', false, 'name', false); ?></ul>
</div>
      <?php elseif (G2C::get ('top_menu') == "custom") : ?>
<div id="pagenav">
  <ul><?php echo G2C::get ('top_custom') ?></ul>
</div>
			<?php elseif (G2C::get ('top_menu') == "categories") : ?>
<div id="pagenav">
  <ul><?php wp_list_cats('sort_column=name&optioncount=0&hierarchical=0'); ?></ul>
</div>
      <?php endif;
		}

    function page_links ($show_if_empty = true)
    {
      ob_start ();
      next_posts_link (_g('Next Page &raquo;'));
      $nextlinks = ob_get_contents ();
      ob_end_clean ();

      ob_start ();
      previous_posts_link (_g('&laquo; Previous Page'));
      $prevlinks = ob_get_contents ();
      ob_end_clean ();

      if ($prevlinks)
        echo "<li>$prevlinks</li>";
      else if ($show_if_empty)
        echo "<li><p>"._g ('&laquo; Previous Page')."</p></li>";

      if ($nextlinks)
        echo "<li>$nextlinks</li>";
      else if ($show_if_empty)
        echo "<li><p>"._g ('Next Page &raquo;')."</p></li>";
    }

    function linky ($num, $next = '')
    {
      if ($next)
        $title = $next;
      else
        $title = sprintf (_g("Go to page %s"), $num);
      if ('' == get_settings ('permalink_structure'))
        return '<a title="'.$title.'" href="'.get_permalink ().'&amp;page='.$num.'">';
      else
        return '<a title="'.$title.'" href="' . trailingslashit( get_permalink() ) . $num . '/">';
    }


    function link_pages ($wrap = true, $ret = false)
    {
      global $id, $page, $numpages, $multipage, $more;
      global $pagenow;

      if (is_single () && $multipage)
      {
        if ($wrap)
          $str = "<ul>";

        if ($page != 1)
          $str .= "<li>".G2::linky ($page - 1, _g('Go to previous page'))."&lt;</a></li>";

        for ($i = 1; $i < ($numpages+1); $i = $i + 1)
        {
          if ($i == $page)
            $str .= '<li class="active">';
          else
            $str .= '<li>';

          $str .= G2::linky ($i);
          $str .= $i;
          $str .= "</a></li>";
        }

        if ($page != $numpages)
          $str .= "<li>".G2::linky ($page + 1, _g('Go to next page'))."&gt;</a></li>";

        if ($wrap)
          $str .= "</ul>";

        if ($ret == true)
          return $str;
        echo $str;
      }
    }

    function bottom_menu ()
    {
      if (is_archive ())
        G2::page_links ();
      else if (!is_search ())
        G2::page_links (false);
      else
        echo "<li>&nbsp;</li>";
    }

    function disable_plugins ()
    {
      if (function_exists ('inscript_disable'))
       inscript_disable ();
    }



    function group_comments ($comms)
    {
      global $group_pings, $group_comments;
      if (count ($comms) > 0)
      {
        foreach ($comms AS $comm)
        {
          if ($comm->comment_type == 'pingback' || $comm->comment_type == 'trackback')
            $group_pings[] = $comm;
          else
            $group_comments[] = $comm;
        }
      }
    }

    function comments_number ( $zero = 'No Comments', $one = '1 Comment', $more = '% Comments', $number = '' )
    {
    	if ($number == 0) {
    		$blah = $zero;
    	} elseif ($number == 1) {
    		$blah = $one;
    	} elseif ($number  > 1) {
    		$blah = str_replace('%', $number, $more);
    	}
    	echo apply_filters('comments_number', $blah);
    }

    function gravatar ($id)
    {
      if (function_exists ('gravatar') && G2C::get ('gravatar') != 'false')
      { ?>
        <a href="<?php comment_author_url() ?>#"><img alt="Author" align="left" class="gravatar<?php if ($comment->user_id != 0) echo " author" ?>" src="<?php gravatar ('', 40, get_bloginfo ('template_url')."/skin/".get_option ('giraffe_scheme')."/gravatar.png") ?>"/></a>
      <?php }
    }
	}
}

?>
